

This markdown file is a tutorial to run experiments with the measurement node.

## 1- Run experiments manually

Import note : To run experiments you have to launch two terminals of the docker behavior_generator in bash mode.
In the first bash we will run the ros node measurement pipeline.
In the second bash we will run the ros service that will allow to start and stop the measurements. 

### To launch the docker behavior generator in bash mode, run the following command : 

`docker exec -it behavior_generator bash`

### 1 - In the first terminal, launch the measurement node :

`roslaunch measurement_pipeline measurement.launch`

### 2 - In the second terminal, run the following commands :

- To start measurement : `rosservice call /measurement_server "start: true"`

- To stop measurement : `rosservice call /measurement_server "start: false"`


## 2- Example of bash script to run measurements

```bash
#!/bin/bash

set -e

# Bash command to make the robot navigate to initial position
roslaunch robot_behavior behavior_go_to_position_action_client.launch timeout:=100 continuous:=False go_to_target_pose:='[1.5, 3.5, -1.5, 0, 1]'

# While loop to run multiple repetition  of the same experiment
read -p "Start measurement ? [y/n]" start
while [ $start == 'y' ]
do
  # Bash command to start the measurement node
  rosservice call /measurement_server "start: true" 
  
  # Bash command to wait one second - To let the measurements starts
  sleep 1

  # Bash command to make the robot navigate to goal position
  roslaunch robot_behavior behavior_go_to_position_action_client.launch timeout:=100 continuous:=False go_to_target_pose:='[1.5, 0.5, -1.5, 0, 1]'
  
  # If condition to stop the measurements [once this line is reached, it means the former command is done] 
  read -p "Stops measurement ? [y]" stop
  if [[ $start == 'y' ]]; then
    # Bash command to stop the measurement node
    rosservice call /measurement_server "start: false"

    # Bash command to make the robot navigate again to initial position
    roslaunch robot_behavior behavior_go_to_position_action_client.launch timeout:=100 continuous:=False go_to_target_pose:='[1.5, 3.5, -1.5, 0, 1]'
  fi
  read -p "Start measurement again? [y/n]" start
done
```



