import roslib
import rospy
import tf

from geometry_msgs.msg import PoseStamped
from spring_msgs.msg import GoToPositionAction,GoToPositionActionGoal
#
# This node takes a navigation goal published from rviz (topic /move_base_simple/goal)
# and send it to our behavior_generator (topic /behavior_generator/go_to_position_action/goal)
#
def callback(data):
    global running
    global pub
    newgoal = GoToPositionActionGoal()
    # we get goal orientation in quaternion form, we need to convert into euler and get the last of the 3 values
    theta=tf.transformations.euler_from_quaternion([data.pose.orientation.x, data.pose.orientation.y, data.pose.orientation.z, data.pose.orientation.w], axes='sxyz')
    newgoal.goal.go_to_target_pose = [data.pose.position.x, data.pose.position.y, theta[-1], 0.0, 1.0]
    newgoal.goal.timeout= 500
    newgoal.goal.continuous=False
    pub.publish(newgoal)
    running=True


if __name__ == '__main__':
    running=False
    rospy.init_node('rviz_goal_listener', anonymous=True)

    rospy.Subscriber("/move_base_simple/goal", PoseStamped, callback)
    pub=rospy.Publisher('/behavior_generator/go_to_position_action/goal', GoToPositionActionGoal, queue_size=1, latch=True)
    rospy.spin()
